package app2;
/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define DEMO
////#define VERSION_SOLO
////#define FRANCK
////#define LASTPING
////#define RESYNC

//#endinclude
/*
 * Created on 18 juin 2004
 */




import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;


import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.Button;
import com.nttdocomo.ui.Component;
import com.nttdocomo.ui.ComponentListener;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Label;
import com.nttdocomo.ui.ListBox;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.SoftKeyListener;
import com.nttdocomo.ui.TextBox;
import com.nttdocomo.ui.UIException;
import com.nttdocomo.ui.VisualPresenter;

/**
 * @author Cybernash, Maxime Wozny ,Alexandre Garc, Moez Habib Thameur, Franck CARON
 */
public class IHMGasp /*extends GASPClient*/ implements ComponentListener,/*CommandListener,*/
        Runnable {
	
	protected App app;
  
    /**
	 * RMS
	 */ 
  //  private RecordStore recStore = null;
  //  private String dbRMS ="db_User1";
    
    /**
     * GASP ID 
     */ 
    private int aID;
    private int sID;
   // private int sIDToRemove;
    public int aSID;
    	
    /**
     * GASP Infos
     */
    public boolean isOwner = false;
    private boolean isChangePseudo = false;
    private boolean isCreateSession = false;
    private int ownerASID;
    private int[] currentAIIDList;
    public Vector appInstances;
    //public Vector gameSessionPlayers;
    private boolean firstPlayer;
   // private Integer integer;
    public String pseudoname;
    private int min;
    private int minActors=0;
    private int maxActors=0;

    private Hashtable htGameSessionPlayers;
    
    private String currentCommand;

	static int keyEvent;

    
    /**
     * mode, player is in:
     * 0 -> mainscreen
     * 1 -> lobby 
     * 2 -> waitingRoom
     * 3 -> inGame
     */
    public int mode; 
    private int  indexInTheList=0;
    
    private ListBox list;
    
    private Label labLogin,labPassword,labVersion,labMinimum,labMaximum, labPseudo ;
    private TextBox tbLogin, tbPassword, tbNote, tbVersion, labPrivateText,tbPrivate, tbMinimum, tbMaximum, tbPseudo ;
    private Button btJoin, btCreate, btOptions;
 
    static Panel panelLogin, panelPseudo, panelCreation, panelLobby, panelWaiting, panelLaunch;
    
    private VisualPresenter presenterCnam, presenterInt;
    
   // private Thread commandThread;
   
    /** 
     * Initialize the Iapplication with a handle to the current display 
     */
    public IHMGasp(App m) {
        app = m;
        //display = Display.getDisplay(app);
        appInstances = new Vector();
        isOwner = false;
        htGameSessionPlayers = new Hashtable();
        mode = 0;        
   }
    
    /**
     * Debug output routine.
     * @param s string to be printed.
     */
    static final void DEBUG(String s) {
        if (true) {
            System.out.println(s);
        }
    }
    
    
	public void start() {
		mode = 30;  
		currentScreen();
	}
     
	public void componentAction(Component source, int type, int param) {
		if (type==BUTTON_PRESSED){
			if (source==btJoin){
				//System.out.println("le bouton join a ete utilise");
				currentCommand = "joinCommand";
				//currentScreen();
				run();
				//System.out.println("le bouton join a ete utilise encore???");
			}
			if (source==btCreate){
				mode = 11;
				currentCommand = "createCommand";
				currentScreen();
			}
			if (source==btOptions){
				//System.out.println("le bouton option est appuy");
				currentCommand = "pseudoCommand";
				run();
			}
		}
		if (mode==0){ // login screen
			if (source==tbLogin){
				if (type==TEXT_CHANGED){
					tbLogin.getText();
				    tbLogin.setInputMode(TextBox.ALPHA);
				}
			}
			if (source==tbPassword){
				if (type==TEXT_CHANGED){
					tbPassword.getText();
				    tbPassword.setInputMode(TextBox.ALPHA);
				}
			}
		}
		if (mode ==1){
			if (source==list){
				indexInTheList = list.getSelectedIndex();
			}
		}
	}
	
    
	 /*********************
	  * SoftKey Management
	  **********************/  
	
    SoftKeyListener sKL = new SoftKeyListener(){
		public void softKeyPressed(int softKey) {
		        
				if (mode == 0){
		            // gestion de la touche Exit du panelLogin 		 
		            if (softKey == Frame.SOFT_KEY_1){
		        		currentCommand = "exitCommand";
		            }
		            // gestion de la touche Login du panelLogin
		            if (softKey == Frame.SOFT_KEY_2){
		    			currentCommand = "loginCommand";
		            } 
		        }
		        if (mode == 1){
		            // gestion de la touche Quit du panelLobby
		            if (softKey == Frame.SOFT_KEY_1){
		            	//System.out.println("la touche quit du panel Lobby a ete appuyee");
		    			//mode = 1;
		            	currentCommand = "exitCommand";
		            }
		            // gestion de la touche Refresh du panelLobby
		            if (softKey == Frame.SOFT_KEY_2){
		    			currentCommand = "lobbyRefreshCommand";
		            }   	
		        }
			    if (mode == 2){
		            // gestion de la touche Start du panelWaiting (uniquement pour le Owner)
		            if (softKey == Frame.SOFT_KEY_2){
		    			currentCommand = "startCommand";
		            }
		            // gestion de la touche Quit du panelWaiting
		            if (softKey == Frame.SOFT_KEY_1){
		            	//System.out.println("la touche quit du waiting est utilisee");
		            	//NetworkCom.stopComThread();
		            	NetworkCom.threadStarted=true;
		            	Dialog dialogQuit = new Dialog (Dialog.DIALOG_YESNO,"Quit");
		            	dialogQuit.setText("To go back to Gasp Log On : Select Yes. To go back to Lobby: Select No.");
		            	int resultButton = dialogQuit.show();
		    	        	if (resultButton ==Dialog.BUTTON_YES){
		    	        		currentCommand = "quitCommand";	
		    	        	}
		    		       	if (resultButton ==Dialog.BUTTON_NO){
		    		       		//System.out.println("Waiting Room...quitAICommand");
		    		       		currentCommand = "quitAICommand";
		    		        }
		    	        }
		        }
			    if (mode==11){
		            // gestion de la touche Ok du panelCreation
		            if (softKey == Frame.SOFT_KEY_2){
		    			mode=2;
		            	currentCommand = "confirmCommand";

		            }
		            // gestion de la touche Back du panelCreation
		            if (softKey == Frame.SOFT_KEY_1){
		            	mode=1;
		            	//System.out.println("la touche Back a t appuye du panelCreation");
		    			currentCommand = "cancelCommand";
		            }
		        }
			    if (mode==21){
		            // gestion de la touche Ok du panelPseudo
		            if (softKey == Frame.SOFT_KEY_2){
		            	//System.out.println("la touche ok du panelPseudo est touchee");
		    			currentCommand = "okCommand";
		            }
		            // gestion de la touche Back du panelPseudo
		            if (softKey == Frame.SOFT_KEY_1){
		            	//System.out.println("la touche cancel du panelPseudo est touchee");
		    			currentCommand = "cancelCommand";
		            }
		        }
   		run();
        }
		public void softKeyReleased(int softKey) {	
			if (mode == 30){
	        	if (softKey == Frame.SOFT_KEY_2){
	        		//System.out.println("lancement de l'application");
	        		mode = 0;
	        		currentScreen();
	        	
	        	}
	        }
		run();
		}
    };
    
 
	/**
     * Pause signals the thread to stop by clearing the thread field.
     * If stopped before done with the iterations it will
     * be restarted from scratch later.
     */
   /* public void startApp() {
        currentScreen();
    }
 */
    /**
     * Respond to commands, including exit
     * @param c command to perform
     * @param s Screen displayable object
     */
  /*  public void commandAction(Command c, Displayable s) {
        synchronized (this) {
            if (commandThread != null) {
                // process only one command at a time
                return;
            }
            currentCommand = c;
        	commandThread = new Thread(this);
        	commandThread.start();
        }
    }*/
    
    
    public void run() {
    	try{
        if (currentCommand == "exitCommand") {
        	alertScreen("You are leaving the application!");
        	currentCommand = "";
        	quit();
        	mode = 30;
        	currentScreen();
        	app.destroyApp(true);
        	//app.notifyDestroyed();
        } else if (currentCommand == "loginCommand") {
        	//System.out.println("debut du login avant connexion");
        	/*firstLogin(tbLogin.getText(),tbPassword.getText());*/
        	if ("".equals(tbLogin.getText())){
        		alertScreen("To be connected to the Gasp platform, you must fill the login field");
        		mode=0;
        	}
        	else login(tbLogin.getText()/*tfLogin.getString()*/,tbPassword.getText()/*tfPwd.getString()*/);
          	if (sID>0){
          		mode=1;
        	    appInstances = networkCom.getApplicationInstances(sID);
          	}
        	else alertScreen("Session has not been created");
        	currentScreen();
    	} else if (currentCommand == "joinCommand") {
    		System.out.println("join begining...");
    	    join();
    	    if (aSID != 0) mode = 2;
    	    else alertScreen("This game session is no more joinable.");
        	currentScreen();
        } else if (currentCommand == "createCommand") {
        	mode = 11;
        	//System.out.println("le traitement create demarre");
            currentScreen();
        } else if (currentCommand == "lobbyRefreshCommand") {
        	appInstances = networkCom.getApplicationInstances(sID);
    	    currentScreen();
    	} else if (currentCommand == "quitCommand") {
            if (isOwner){
            	if (mode == 2){
            	    //quitAI();
            		removeAllPlayers();
            		//gameSessionPlayers.removeAllElements();
              		// networkCom.quitAI(aSID);
              	}
            	mode = 0;
            	quit();
        	    aSID=0;
        		
            }
            else if (mode!= 1){ 
                networkCom.quitAI(aSID);
                aSID = 0;
                removeAllPlayers();
        	    //gameSessionPlayers.removeAllElements();
            }
           // System.out.println(" Run there is a quit: "+ sID);
			//System.out.println(" Run ... sID to Remove: "+ sIDToRemove);
            networkCom.quit(sID);
            mode = 0;
            tbPassword.setText(""); /*tfPwd.setString("");*/
            currentScreen();
        } /*else if (currentCommand == eventsCommand) {
        	networkCom.getEvents(aSID);
    	} */else if (currentCommand == "startCommand") {
        	if (networkCom.startAI(aSID)){
        		startGame();
        		isOwner = true;
        	}
        	else {
        		alertScreen("You cannot start the game. Minimum of players is : "+min);
        		mode=2;
        		}        	
        	currentScreen();
    	} /*else if (currentCommand == dataCommand) {
        	currentScreen();
    	} else if (currentCommand == endCommand) {// this command is a command from the game!
    		networkCom.endAI(aSID);
        	mode = 2;
    	    currentScreen();
    	} */else if (currentCommand == "quitAICommand") {// quit the waiting room and go back to Lobby
    		//System.out.println(" quitAICommand treatment....");
    		networkCom.quitAI(aSID);
    		NetworkCom.stopComThread();
    		//System.out.println("quitAICommand.....NetworkCom.threadStarted..."+NetworkCom.threadStarted);
    		this.quitAI();
    		aSID = 0;
    		removeAllPlayers();
    	    //gameSessionPlayers.removeAllElements();
    	    mode = 1;
    	    appInstances.removeAllElements();
    	    currentScreen();
    	} else if (currentCommand == "pseudoCommand") {
    		//System.out.println("le traitement pseudo commande dmarre");
    	    changePseudoScreen();
    	}else if (currentCommand == "okCommand") {
    		//System.out.println("ChangePseudo method is called now:...");
    		changePseudo();
    		mode = 2;
    	    currentScreen();
    	} else if (currentCommand == "cancelCommand") {
    		cancelValue();
       	}else if (currentCommand == "confirmCommand" && isCreateSession == false) {
    		firstPlayer = true;
    		isOwner = true;
    		//System.out.println(" confirmCommand in the run");
    		create();
    	} 
    	
    	}catch (Exception e){ 
    		System.out.println("a pb occurs in the Run");
    		e.printStackTrace();}

     /*   synchronized (this) {
            // signal that another command can be processed
            commandThread = null;
        }*/
    }
 
    /**
 	 * This method is called when a player try to create a game session.
	 * A player can create a public game session or a private game session
	 */
   
	private void create() {
		if (isCreateSession==false){
			try {
				String minActorsTxt = tbMinimum.getText();
				String maxActorsTxt = tbMaximum.getText();
				String actorsHttp = tbPrivate.getText()/*tfPriv.getString()*/;
				//System.out.println(" create in the IHMGasp");
				if ("".equals(minActorsTxt)){
					minActors = 0;
				}else if ("".equals(maxActorsTxt)){
					maxActors = 0;
				}else {
					minActors = Integer.parseInt(tbMinimum.getText()/*tfMin.getString()*/);
					maxActors = Integer.parseInt(tbMaximum.getText()/*tfMax.getString()*/);
				}
				if (minActors==0){
					alertScreen ("A multiplayer game begins with 2 players!!!!");
					mode =11;
					currentScreen();
				}
				else if (minActors>maxActors || maxActors<=0){		
					alertScreen("The session could not be started. Min > Max");
					mode =11;
					currentScreen();
					}
				else if (maxActors>0 /*"".equals(actorsHttp)*/){
					//System.out.println("networkCom.createAI(sID,minActors,maxActors)");
					aSID = networkCom.createAI(sID,minActors,maxActors);
					//System.out.println("sID is : "+sID);
					//System.out.println("creation of a session aSID is : "+aSID);
					isCreateSession = true;
					min=minActors;
					mode =2;
					currentScreen();
					}
				else if (! "".equals(actorsHttp)){
					/**TODO: private session  /aSID = createAIPriv(sID,actorsHttp,minActors,maxActors);*/
						alertScreen("Private Session is not available yet!");
						mode = 11;
					/*min = minActors;
					mode=2;*/
					currentScreen();
					}
					
			}
			catch  (NumberFormatException e) {
				alertScreen("The session cannot be started. Min or Max are not valid");
				maxActors=0;
				minActors=0;
				mode = 11;
				currentScreen();
				e.printStackTrace();
			}
			
		}
		else System.out.println(" the creation is done!");
	}

	/**
     * This methods provides to draw the appropriate screen.
     */
    public void currentScreen() {
        switch (mode){
        	case 0:
        	    mainScreen();
        	    break;
        	case 1:
        	    lobbyScreen();
        	    break;
        	case 2:
        	    waitingRoomScreen();
        	    break;
        	case 11:
        		createScreen();
        		break;
        	case 21:
        		changePseudoScreen();
        		break;
        	case 30:
        		launchScreen();
        		break;
        	/*case 3:
        	    inGameScreen();*/
                    	    
        	default: break;	    
        } 
    }
    /**
     *  Link to the network communication object
     */
    private NetworkCom networkCom;
    
    /**************************************/
    /********* Displays management ********/
    /**************************************/
   
    /**
     * Launch screen
     */
    void launchScreen(){
        panelLaunch = new Panel();
        panelLaunch.setTitle("Launch GASP Demonstrator");
        panelLaunch.setSoftLabel(Frame.SOFT_KEY_2,"Launch");
    	Display.setCurrent(panelLaunch);
    	panelLaunch.setSoftKeyListener(sKL);
    	
    }
    /**
     * Main screen.
     */
    void mainScreen() {
        panelLogin = new Panel();
        panelLogin.setTitle("GASP Log On");// titre de l'cran
        tbNote = new TextBox("Note: This is a GASP Demonstrator. Let's hope it works!",20,2,TextBox.DISPLAY_ANY);
        tbNote.setEditable(false);
       	
        labLogin = new Label ("Login ", Label.CENTER); 
        //on rcupre une chaine alphanumrique (en clair) dans cette boite (loginBox)
        tbLogin = new TextBox ("",10,1,TextBox.DISPLAY_ANY);     
        tbLogin.setInputMode(TextBox.ALPHA);
        
        labPassword = new Label ("Password", Label.CENTER);
        //on rcupre une chaine alphanumrique ("chiffre") dans cette boite (passwordBox)
        tbPassword = new TextBox ("",10,1, TextBox.DISPLAY_PASSWORD);
        tbPassword.setInputMode(TextBox.ALPHA);
        
        labVersion = new Label ("Version", Label.CENTER);
        tbVersion =  new TextBox ("Doja Version: 1.0.1 ",15,1, TextBox.DISPLAY_ANY);
        tbVersion.setEditable(false);
        
        
        //prparation pour l'affichage des images cnam.gif et int.gif
        presenterCnam = new VisualPresenter();
        presenterInt = new VisualPresenter();
        
        MediaImage mediaImage = MediaManager.getImage("resource:///cnam.gif");
        MediaImage mediaImage2 = MediaManager.getImage("resource:///int.gif");
        
        try {
 			mediaImage.use();
 			mediaImage2.use();
		} catch (ConnectionException e) {
			e.printStackTrace();
		} catch (UIException e) {
			e.printStackTrace();
		}
      
		presenterCnam.setImage(mediaImage);
		presenterInt.setImage(mediaImage2);
        presenterCnam.setSize(40,presenterCnam.getHeight());
        presenterInt.setSize(80,presenterInt.getHeight());
        
        //affichage de chacun des labels, des textbox et de l'image
        if (mode==0){
            panelLogin.add(tbNote);
            panelLogin.add(labLogin);
            panelLogin.add(tbLogin);
            panelLogin.add(labPassword);
            panelLogin.add(tbPassword);
            panelLogin.add(labVersion);
            panelLogin.add(tbVersion);
 
            panelLogin.add(presenterCnam);
            panelLogin.add(presenterInt);
           
            //affichage des SoftKeys : Quit et Login 
            panelLogin.setSoftLabel(Frame.SOFT_KEY_1,"Quit");
            panelLogin.setSoftLabel(Frame.SOFT_KEY_2,"Login");
        }

       	Display.setCurrent(panelLogin);
        tbLogin.setText("");
    	tbPassword.setText("");
    	panelLogin.setComponentListener(this);    
    	panelLogin.setSoftKeyListener(sKL);
       	networkCom = new NetworkCom(this);
        /*
        formLogin.setCommandListener(this);
    	display.setCurrent(formLogin);
    	networkCom = new NetworkCom(this);
        tfPwd.setString("");*/
    }
    
    /**
     * Lobby screen.
     */
    void lobbyScreen() {
    	try{
	        panelLobby = new Panel(); 
	        panelLobby.setTitle("GASP Lobby Room");// titre de l'cran
      	// ajout des boutons Join et Create
	      	btJoin = new Button("Join");
	      	btCreate = new Button("Create");
	
	        panelLobby.setSoftLabel(Frame.SOFT_KEY_1,"Quit");
	        panelLobby.setSoftLabel(Frame.SOFT_KEY_2,"Refresh");
   
    	    firstPlayer = false;
    	    isOwner = false;
    	    //appInstances = networkCom.getApplicationInstances(sID);
    	    int  indexMax = appInstances.size();
	    	currentAIIDList = new int[indexMax];
	    	//System.out.println("indexMax:" + indexMax);
    		panelLobby.setComponentListener(this);
    		panelLobby.setSoftKeyListener(sKL);
    		//Display.setCurrent(panelLobby);
    	
	    	if (indexMax == 0){
	    		//System.out.println("pas de partie possible");
	    		infoScreen("Note: Currently no game sessions to join");
	    		panelLobby.add(btCreate);
	    		//Display.setCurrent(panelLobby);
	    		
	    	  /*  String s = "Note: Currently no game sessions to join";
	    	    t = new TextBox("GASP: Lobby Room", s, s.length(), 0);
	    	    setCommands(t, 1);
	    	    t.setCommandListener(this);
	    	    display.setCurrent(t);*/
	    	}
	    	else{
	    		//panelLobby.setComponentListener(this);
	    		//Display.setCurrent(panelLobby);
	    		ListBox list = new ListBox(ListBox.SINGLE_SELECT);
	    		list.append("Random session");
	    		
	    	   /* list = new List("GASP: Lobby Room", Choice.EXCLUSIVE);
	    	    list.setCommandListener(this);
	    	    list.append("Random session", null);*/
	    	    
		        for (int i = 0; i < appInstances.size(); i++) {
		            ApplicationInstanceInfos appInfos = (ApplicationInstanceInfos)appInstances.elementAt(i);
		            currentAIIDList[i] = appInfos.getApplicationInstanceID();
		            int aIID = appInfos.getApplicationInstanceID();
		            int nbP = appInfos.getNbPlayers();
		            int min = appInfos.getMinActors();
		            int max = appInfos.getMaxActors();
		            list.append("ApplicationInstanceID: "+aIID+ " nbPlayers: "+min+"/"+ nbP+"/"+ max/*, null*/);
		        }
		        panelLobby.add(list);// permet l'affichage de toute la liste des sessions joignables
		        /*  setCommands(list, 2);
		        display.setCurrent(list);*/
		        panelLobby.add(btJoin);
		      	panelLobby.add(btCreate);
	    	}
	    	Display.setCurrent(panelLobby);
    	}
    	catch (Exception e){
    		System.out.println(" a pb occurs in the Panel Lobby");
    		e.printStackTrace();}
    }
    
    /**
     * Waiting room screen.
     */
    void waitingRoomScreen() {
        try{
            panelWaiting = new Panel();
            panelWaiting.setTitle("Gasp :  Waiting Room");
            btOptions = new Button("Pseudo");
            
    		panelWaiting.setComponentListener(this);
    		Display.setCurrent(panelWaiting);
            panelWaiting.setSoftLabel(Frame.SOFT_KEY_1,"Quit");
            if (isOwner){
                panelWaiting.setSoftLabel(Frame.SOFT_KEY_2,"Start");	
            }
            panelWaiting.setSoftKeyListener(sKL);
        	networkCom.startComThread();
    		ListBox listPlayer = new ListBox(ListBox.NUMBERED_LIST);
    		DEBUG("gameSessionPlayers : "+htGameSessionPlayers.size());
	    	/*list = new List("Waiting Room - Players", Choice.EXCLUSIVE);
	    	list.setCommandListener(this);*/
	    	Enumeration enume= htGameSessionPlayers.keys();
	    	while (enume.hasMoreElements()){
	    		short pid = Short.parseShort((String) enume.nextElement());
	     		if (pid == ownerASID){
	     			if (ownerASID== aSID) 
	     				listPlayer.append("Owner(you): "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")");
	     			else
	     				listPlayer.append("Owner: "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")");   
	     		}
	     		else {
	     			if (pid == aSID){
	     				listPlayer.append("Player(you): "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")");
	     			}
	     			else 
	     				listPlayer.append("Player: "+htGameSessionPlayers.get(""+pid)+" ("+aID+","+sID+","+aSID+")");
	     			}
	    	}
	    	
	      /*  for (int i = 0; i < gameSessionPlayers.size(); i++) {
	        	Integer aSIDOf = new Integer(0);
	        	try {
	        		aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
	        	}
	        	catch (Exception e){
	        	}
	        	//System.out.println("ownerASID  :"+ownerASID);
	            if (aSIDOf.intValue()== ownerASID){
	                if (ownerASID == aSID) {
	                    listPlayer.append("Owner(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                	//System.out.println("---------- ownerASID == aSID "+ ownerASID+" "+aSID);
	               	}
	                else
	                	listPlayer.append("Owner: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);
	            }
	            else{
	             /*   if (aSIDOf.intValue()== aSID){
	                	
	                	listPlayer.append("Player(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                	//System.out.println("////// aSIDOf.intValue()== aSID "+ aSIDOf.intValue()+" "+aSID);
	               // }
	      
	                //else 
	                	//listPlayer.append("Player: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);	
	            //}
	            //i++;
	    	//}*/
	        panelWaiting.add(listPlayer);
	        panelWaiting.add(btOptions);
	       /* setCommands(list, 3);
            display.setCurrent(list);*/
    	}
        catch (Exception e){
    		System.out.println("a pb occurs in the Waiting Room Screen");
    		e.printStackTrace();}
    }
    
	/**
	 * Create screen
	 * Perform a GASP create form to have min and max players
	 * + private game authorized actors list if necessary
	 */
	void createScreen() {	
        try{
            panelCreation = new Panel();         
            panelCreation.setTitle("Creation Screen: Number of Players");// titre de l'cran
            labMinimum = new Label("Minimum:",Label.LEFT);
            tbMinimum = new TextBox("Minimum:",7,1, TextBox.NUMBER);
            tbMinimum.setInputMode(TextBox.NUMBER);
            
            tbMaximum = new TextBox("Maximum:",7,1, TextBox.NUMBER);
            labMaximum = new Label("Maximum:",Label.LEFT);
            tbMaximum.setInputMode(TextBox.NUMBER);
            
            labPrivateText = new TextBox ("Note:If you want to create a private game, " +
            		"enter the authorized actors." +
            		"Please follow this pattern: 1_50_10_45_2",40,3,TextBox.DISPLAY_ANY);
            labPrivateText.setEditable(false);
            tbPrivate = new TextBox("",40,1,TextBox.DISPLAY_ANY);
            tbPrivate.setInputMode(TextBox.ALPHA);
            // Private session is not available for this demonstrator
            tbPrivate.setEditable(false);
            
            panelCreation.add(labMinimum);
            panelCreation.add(tbMinimum);
            panelCreation.add(labMaximum);
            panelCreation.add(tbMaximum);
            panelCreation.add(labPrivateText);
            panelCreation.add(tbPrivate);
            
            panelCreation.setSoftLabel(Frame.SOFT_KEY_1,"Back");
            panelCreation.setSoftLabel(Frame.SOFT_KEY_2,"Ok");

            Display.setCurrent(panelCreation);
        	tbMinimum.setText("");
        	tbMaximum.setText("");
            
        	panelCreation.setComponentListener(this);
        	panelCreation.setSoftKeyListener(sKL);

    		/*
    		tfMin.setString("");
    		tfMax.setString("");
        	formMinmax.setCommandListener(this);
        	display.setCurrent(formMinmax);*/
        	
    	}
    	catch (Exception e){
    		System.out.println(" a pb occurs in the panelCreation");
    		e.printStackTrace();
    		}
    }

    
    /**
     * ChangePseudo screen.
     */
    void changePseudoScreen() {
        try{
        	mode = 21;
        	isChangePseudo = true;
        	
        	panelPseudo = new Panel();
        	panelPseudo.setTitle("Options : change your own Pseudoname!");
        	labPseudo =  new Label("Pseudo : ",Label.LEFT);
        	tbPseudo = new TextBox("",8,1,TextBox.DISPLAY_ANY);
        	tbPseudo.setInputMode(TextBox.ALPHA);
        	
        	panelPseudo.add(labPseudo);
        	panelPseudo.add(tbPseudo);
        	panelPseudo.setSoftLabel(Frame.SOFT_KEY_1,"Back");
        	panelPseudo.setSoftLabel(Frame.SOFT_KEY_2,"Ok");
        	
        	panelPseudo.setComponentListener(this);
        	panelPseudo.setSoftKeyListener(sKL);
        	
        	pseudoname = networkCom.name(aSID, tbPseudo.getText()/*tfPseudo.getString()*/);
        	tbPseudo.setText((String) htGameSessionPlayers.get(""+aSID));
        	/*tfPseudo.setString((String) gameSessionPlayers.elementAt(getIndex(aSID)+1));*/
        	DEBUG("Pseudo in the panelPseudo is..."+ tbPseudo.getText()/*tfPseudo.getString()*/);
        	panelPseudo.setComponentListener(this);
        	Display.setCurrent(panelPseudo);
        	/*
        	formPseudo.setCommandListener(this);
	    	display.setCurrent(formPseudo);*/
	    	
    	}
    	catch (Exception e){
    		System.out.println("a pb occurs in the Panel Pseudo");
    		e.printStackTrace();}
    }
    
    
    /**
     * In Game screen.
     */
  /*  void inGameScreen() {
        try{
        	networkCom.getEvents(aSID);
	    	list = new List("In Game", Choice.EXCLUSIVE);
	    	list.setCommandListener(this);
	        for (int i = 0; i < gameSessionPlayers.size(); i++) {
	            Integer aSIDOf = (Integer)gameSessionPlayers.elementAt(i);
	            if (aSIDOf.intValue()== ownerASID){
	                if (ownerASID == aSID)
	                    list.append("Owner(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	     
	                else
	                    list.append("Owner: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);
	            }
	            else{
	                if (aSIDOf.intValue()== aSID)
	                    list.append("Player(you): "+gameSessionPlayers.elementAt(i+1)+" ("+aID+","+sID+","+aSID+")",null);
	                else 
	                    list.append("Player: "+gameSessionPlayers.elementAt(i+1)+" ("+aSIDOf+")",null);	
	            }
	            i++;
	    	}
	        setCommands(list, 4);
	        display.setCurrent(list);
    	}
    	catch (Exception e){e.printStackTrace();}
    }
  */    
    /**
     * Alert screen.
     */
  /*  synchronized void alertScreen(String s) {
        t = new TextBox("Alert", s, s.length(), 0);
        display.setCurrent(t);
        try {
            Thread.sleep(1300);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }*/
    
    synchronized void alertScreen(String s) {
    	Dialog alert = new Dialog(Dialog.DIALOG_WARNING,"Warning");
    	alert.setText(s);
    	alert.show();
    }
    synchronized void infoScreen(String s) {
    	Dialog info = new Dialog(Dialog.DIALOG_INFO,"Info");
    	info.setText(s);
    	info.show();
    }
     
    /**
     * Cancel command 
     * Go back to previous screen (lobby screen or inGame screen)
     */
    private void cancelValue(){
    	if (isChangePseudo){
    		changePseudo();
    		waitingRoomScreen();
    		isChangePseudo = false;
    	}
    	else {
           	tbMinimum.setText("");
        	tbMaximum.setText("");
        	/*
    		tfMin.setString("");
    		tfMax.setString("");*/
    		lobbyScreen();
    	}  		
      }
    
    /**
     * Test the change pseudo function.
     */
    private void changePseudo() {
    	isChangePseudo = true;
    	pseudoname = networkCom.name(aSID,tbPseudo.getText()/*tfPseudo.getString()*/);
    	if (pseudoname.equals(""))htGameSessionPlayers.put(""+aSID,tbPseudo.getText());
    	else htGameSessionPlayers.put(""+aSID,pseudoname);
    	/*if (pseudoname.equals("")) {
    		gameSessionPlayers.setElementAt(tbPseudo.getText()/*tfPseudo.getString(),getIndex(aSID)+1);
    	}*/
    	/*else {
    		gameSessionPlayers.setElementAt(pseudoname,getIndex(aSID)+1);
    		
    	}*/
    	currentScreen();
    }
   
    /*********************************************/
    /****** specific informations for GASP *******/
    /*********************************************/
    
    /**
     * The application ID on GASP
     */
    private static final int applicationID = 2;
    
    /**
	 * Perform a GASP firstLogin or login,
	 * pick an alert screen and go to lobby screen.
	 */
	private void login(String loginName, String pwd) throws Exception {
	    /*openRecordStore();*/
		//System.out.println("loginName is: "+loginName+" Password is : "+pwd);
		byte[] aIDBytes = null;
		String aIDs = "";
		int nb = 0;
		try {
			//nb = recStore.getNumRecords();
			
			if (nb==0){
				System.out.println("--firstLogin with applicationID:"+applicationID+" loginName: "+loginName+" Pwd: "+pwd);
				int actorID = networkCom.firstLogin(applicationID,loginName,pwd);
				DEBUG("firstLogin called with aID="+actorID);
				aIDs = "aID"+actorID;
				aIDBytes = aIDs.getBytes();
			//	recStore.addRecord(aIDBytes,0, aIDBytes.length);
			}
			else{
			    
			//	aIDBytes = recStore.getRecord(1);
				//System.out.println("affichage de la valeur de aIDS:"+aIDs);
				aIDs = new String(aIDBytes,0,aIDBytes.length);
				DEBUG("login called with aID="+aIDs);
			}
			int i = aIDs.length();
			aIDs = aIDs.substring(3,i);
			aID = Integer.parseInt(aIDs);
			//System.out.println("message avant login sur NetworkCOm");
			sID = networkCom.login(aID,loginName,pwd,"2.0");
			//sIDToRemove = sID;
			DEBUG("login ok: sID n"+sID);
			//nb = recStore.getNumRecords();
		} 
		catch (/*RecordStoreNotOpen*/Exception e) {
			System.out.println("a pb occurs in the Login");
			e.printStackTrace();
		}
		alertScreen("Your infos : ActorID>"+aID+" Session ID>"+ sID);
	}
	
	/**
	 * Perform a GASP joinAIRnd or joinAI,
	 * and go to waitingRoomScreen.
	 */
	private void join() {
		//System.out.println("Join method is begining...");
		if ( indexInTheList /*list.getSelectedIndex()*/==0){
			/**
			 * join random option selected
			 */
			aSID = networkCom.joinAIRnd(sID);
		}
		else{
			//System.out.println(" join... recuperation de l aSID");
			aSID = networkCom.joinAI(sID,currentAIIDList[indexInTheList/*list.getSelectedIndex ()*/-1]);
		}
	}
	
	
	/**
	 *  Open the rms db
	 */
/*	private void openRecordStore() {
		try
	    {
	       /** The second parameter indicates that the record store
	        * should be created if it does not exist
	        */
	      //recStore = RecordStore.openRecordStore(dbRMS, true );
/*	    }
	    catch (Exception e)
	    {
	      System.err.println(e.toString());
	    }
	}
*/
	/**
	 * Write a record in rms db.
	 * 
	 * @param str the string to write
	 */
/*	private void writeRecord(String str)
	  {
	    byte[] rec = str.getBytes();
	 
	    try
	    {
	     // recStore.addRecord(rec, 0, rec.length);
	      DEBUG("Writing record: " + str);
	    }
	    catch (Exception e)
	    {
	      System.err.println(e.toString());
	    }
	  }
	*/
	
    /**********************************************************/
	/** Implementation of the herited GASP events listeners ***/
	/**********************************************************/
    
    public void onJoinEvent(int actorSessionID, String username) {
        /**
         *  the first player join the application instance is the owner
         */
        DEBUG("JoinEvent:" + actorSessionID);
        
        if (actorSessionID == aSID) pseudoname = username;
        
      /*  int i = getIndex(actorSessionID);
        DEBUG("Index of actorSessionID:"+i);
        if(i>=0){
        	// rename case
        	gameSessionPlayers.setElementAt(username,i+1);
        }
        else{*/
        	// no player with this aSID in gameSessionPlayers vector
        	firstPlayer = (htGameSessionPlayers.size() == 0);
        	htGameSessionPlayers.put(""+actorSessionID,username);
        	
           /* gameSessionPlayers.insertElementAt(new Integer(actorSessionID),gameSessionPlayers.size());
            gameSessionPlayers.insertElementAt(username,gameSessionPlayers.size());
            */
            if (firstPlayer){ 
	            ownerASID = actorSessionID;
	            if (ownerASID==aSID){
	                isOwner = true;
	                alertScreen("Note: you are the owner of the game session");
	            }
	            else alertScreen("The game session owner joins: aSID>"+actorSessionID+" username>"+username);
            }
            else{
                if (actorSessionID!=aSID)
                    alertScreen("A new player joins: aSID>"+actorSessionID+" username>"+username);
            }
       // }
        
        currentScreen();
    }
    
   
    /*********************************/
    /******* GAME MANAGEMENT *********/
    /*********************************/
    
    /**
     * game canvas link
     */
    protected GameCanvas gameCanvas;
    
    
    public void startGame() {
    	System.out.println("The game starts!");
    	mode = 3;
        /** 
         * initialize game
         */
    	gameCanvas = new SimpleGameCanvas(app, this, (int) NetworkCom.minimalRequestDeltaTime);
        gameCanvas.initialize();
        
        /**
         *  set game display
         */
        Display.setCurrent(gameCanvas);
        
        /**
         *  start game
         */
		gameCanvas.newGame();
		gameCanvas.restart();
    }
    public void onStartEvent(int actorSessionID) {
    	synchronized (GASPClient.monitor){
	       if (mode == 2){
		    	alertScreen("The game session owner starts the game!");
		    	System.out.println("The game session owner starts the game!");
		    	startGame();
	       }  
    	}
    }

    public void onEndEvent(int actorSessionID) {
        gameCanvas.stop();
       if (ownerASID==actorSessionID){
	    	alertScreen("The game session owner has stopped the game! Return to waiting room.");
 	        }
        else {
        	alertScreen("The player n "+actorSessionID+" left the game alone! ");
 	         }
        mode = 2;
        currentScreen();
    }

    public void onQuitEvent(int actorSessionID) {
    	//System.out.println("onQuitEvent");
    	//System.out.println("owner: "+ownerASID);
    	//System.out.println("actorSessionID: "+actorSessionID);
    	if (mode==2){
	        if (ownerASID == actorSessionID){
	            alertScreen("The game session owner has left the game, the game session has been distructed." +
	            		" Return to the Lobby.");
	            removeAllPlayers();
	           // gameSessionPlayers.removeAllElements();
	            //System.out.println("onquitEvent for the owner");
	            NetworkCom.stopComThread();
	            mode = 1;
	            appInstances.removeAllElements();
	            currentScreen();
	        }
	        else{
	        	if (/*isOwner && */min>htGameSessionPlayers.size()/2)
	            	{
	            	alertScreen("The player n"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
	            	removePlayer(actorSessionID);
	            	}
	        	else {
	        		alertScreen("The player n"+actorSessionID+" has left from lobby");
	        		removePlayer(actorSessionID);
	        		//System.out.println("onquitEvent for a player");
	        	}
	            currentScreen();
	        }
    	}
    	if (mode == 3){
    		if (ownerASID == actorSessionID){
	            alertScreen("The game session owner has left the game, the game has been distructed." +
	            		" Return to the Lobby Room.");
	            removeAllPlayers();
	           // gameSessionPlayers.removeAllElements();
	            gameCanvas.onQuitEvent(actorSessionID);
	            NetworkCom.stopComThread();
	            mode = 1;
	            appInstances.removeAllElements();
	            currentScreen();
	        }
    		else{
    			//gameSessionPlayers.removeElementAt(actorSessionID);
    			removePlayer(actorSessionID);
  				if (/*isOwner &&*/min>htGameSessionPlayers.size()/2)
	            	{
	        		alertScreen("The player n"+actorSessionID+" has left the game" +" Beware! The number of players is too low.");
	        		mode = 2;
	            	currentScreen();
	            	}
	        	else {
	        		alertScreen("The player n"+actorSessionID+" has left the game and go to lobby room or GASP log on");
	        	    gameCanvas.onQuitEvent(actorSessionID);
	        		Display.setCurrent(gameCanvas);
	        	}	
	        }
    	}
    }
    
    
    public void onDataEvent(int actorSessionID, Hashtable datas) {
        if (mode == 3){
        	gameCanvas.onDataEvent(actorSessionID, datas);
        }
    }
    
    
    /**
     * Remove the player corresponding to the actorSessionID.
     * 
     * @param actorSessionID
     */
    private void removePlayer(int actorSessionID) {
    	try {
    		Enumeration enume = htGameSessionPlayers.keys();
    		while (enume.hasMoreElements()){
    			short pid =Short.parseShort((String) enume.nextElement());
    			if (actorSessionID==pid){
    				htGameSessionPlayers.remove(""+actorSessionID);
    			}
    		}
    	}
    	catch (Exception e){
    		System.out.println("a pb occurs in RemovePlayer");
    		e.printStackTrace();
    	}
    }
   
    /**
     * Remove the player corresponding to the actorSessionID.
     * 
     * @param actorSessionID
     */
   /* private void removePlayer(int actorSessionID) {
    	try {
        	for(int i=0; i<gameSessionPlayers.size();i++){
                if (((Integer) gameSessionPlayers.elementAt(i)).intValue() == actorSessionID){
                  gameSessionPlayers.removeElementAt(i);
                break;
               }
               i++;
           }
    	}
    	catch (Exception e){
    	}
    }*/
 
    /**
     * Remove all the players
     */
    
    public void removeAllPlayers(){
    	Enumeration enume=htGameSessionPlayers.keys();
    	while (enume.hasMoreElements()){
    		short pid =Short.parseShort((String) enume.nextElement());
    		removePlayer(pid);
    	}
    }
    
	/**
	 * @return Returns the mode.
	 */
	public int getMode() {
		return mode;
	}

	/***************************************************************************/
	/************************  Link to NetworkCom  *****************************/
	 /**These methods are used to transmit an event from IHMGasp to NetworkCom**/
	 /**************************************************************************/
	
	public void endAI() {
		networkCom.endAI(aSID);
	}


	public void quitAI() {
		//arret du thread a faire.....
		NetworkCom.stopComThread();
		networkCom.quitAI(aSID);
	}


	public void quit() {
		//arret du thread a faire.....
		NetworkCom.stopComThread();
		synchronized(NetworkCom.monitor){
			//System.out.println("there is a quit just after with sID: "+ sID);
			//System.out.println(" sID to Remove: "+ sIDToRemove);
			networkCom.quit(sID);
		}
	}
	
	/**
	 * method is used to transmit a message from GameCanvas to NetworkCom
	 */
	public void sendMessage(Object o) {
		networkCom.addMessageToSend(o);
	}


	public Object update() {
		return gameCanvas.cyclicUpdateMessagesToSend();
	}
	public Object ping() {
		return gameCanvas.cyclicPingPlayerMessagesToSend();
	}


}
	
    
	
