package app2;
/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * @author DELPIANO Fabien - Filao
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */

import java.util.Enumeration;
import java.util.Hashtable;


import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.UIException;


public class ResourcesManager {

	public static final int PNG = 0, JPG = 1, GIF = 2;
	public static final String[] EXTENSIONS = { ".png", ".jpg", ".gif" };
	public static final Object NOT_LOADED = new Object();

	private static Hashtable resources = new Hashtable();

	public static boolean preloadResource(int id, int type) {
		Object result = resources.put(/*"/" +*/ id + EXTENSIONS[type], NOT_LOADED);
		return result == null;
	}

	public static boolean loadEverything() {
		try {
			int i=1;
			for (Enumeration enume = resources.keys(); enume.hasMoreElements();) {
				String key = (String) enume.nextElement();
				//Image img = Image.createImage(key);
				//System.out.println("Chargement image: "+ key);
				/*MediaImage mediaImg = MediaManager.getImage(key);*/
				// le format png ne semble pas reconnu dans la version DOJA????
				//MediaImage mediaImg = MediaManager.getImage("resource:///"+enume+".png");
				MediaImage mediaImg = MediaManager.getImage("resource:///"+i+".gif");
				
				try {
					//System.out.println(" MediaImg.use()..."+i);
		 			mediaImg.use();
		 			i++;
				} catch (ConnectionException e) {
					e.printStackTrace();
				} catch (UIException e) {
					e.printStackTrace();
				}			
				//System.out.println("Chargement ok: "+ mediaImg.getImage());
				resources.put(key, mediaImg.getImage()/*img*/);
			}
		} catch (Exception e) {
			if (App.DEBUG){
				e.printStackTrace();
			}
			return false;
		}
		return true;
	}
	
	public static Image getImage(int id, int type) {
		Object result = resources.get(/*"/" + */id + "" + EXTENSIONS[type]);
		if (result instanceof Image) return (Image)result;
		return null;
	}

	public static Image getImage(int id) {
		return getImage(id, GIF /*PNG*/);
	}

}
